package kaysaar.aotd_question_of_loyalty.data.models;

import com.fs.starfarer.api.impl.campaign.ids.Stats;
import com.fs.starfarer.api.impl.campaign.intel.events.DiktatFuelBonusScript;
import com.fs.starfarer.api.impl.campaign.intel.events.SindrianDiktatStandardActivityCause;
import com.fs.starfarer.api.impl.campaign.intel.events.SindrianDiktatHostileActivityFactor;
import kaysaar.aotd_question_of_loyalty.data.scripts.crisisalt.LuddicMajorityApplier;
import com.fs.starfarer.api.impl.campaign.intel.events.LuddicChurchStandardActivityCause;
import com.fs.starfarer.api.impl.campaign.intel.events.LuddicChurchHostileActivityFactor;
import com.fs.starfarer.api.impl.campaign.intel.events.TriTachyonStandardActivityCause;
import com.fs.starfarer.api.impl.campaign.intel.events.TriTachyonHostileActivityFactor;
import com.fs.starfarer.api.impl.campaign.intel.events.HegemonyAICoresActivityCause;
import com.fs.starfarer.api.impl.campaign.intel.events.HegemonyHostileActivityFactor;
import com.fs.starfarer.api.impl.campaign.intel.events.HostileActivityEventIntel;
import com.fs.starfarer.api.campaign.FactionAPI;
import com.fs.starfarer.api.impl.campaign.intel.TriTachyonDeal;
import com.fs.starfarer.api.impl.campaign.rulecmd.AoTDRetirementOption;
import com.fs.starfarer.api.Global;
import com.fs.starfarer.api.campaign.InteractionDialogAPI;

public class AoTDHandleBonusesFromBeingRetired
{
    public static void applyTTDeal(final InteractionDialogAPI dialogAPI) {
        final RetirementInfo retirementInfo = (RetirementInfo)Global.getSector().getMemory().get(AoTDRetirementOption.memKey);
        if (retirementInfo != null && retirementInfo.getPrevFaction().equals("tritachyon") && TriTachyonDeal.get() == null) {
            new TriTachyonDeal(dialogAPI);
        }
    }
    
    public static void unapplyTTDeal(final InteractionDialogAPI dialogAPI, final FactionAPI factionToJoin) {
        final RetirementInfo retirementInfo = (RetirementInfo)Global.getSector().getMemory().get(AoTDRetirementOption.memKey);
        if (retirementInfo != null && TriTachyonDeal.get() != null) {
            if (factionToJoin.getId().equals("tritachyon")) {
                TriTachyonDeal.get().endAgreement((TriTachyonDeal.AgreementEndingType)null, dialogAPI);
            }
            else {
                TriTachyonDeal.get().endAgreement(TriTachyonDeal.AgreementEndingType.BROKEN, dialogAPI);
            }
        }
    }
    
    public static void applyBonusesFromRetirement(final InteractionDialogAPI dialogAPI) {
        final RetirementInfo retirementInfo = (RetirementInfo)Global.getSector().getMemory().get(AoTDRetirementOption.memKey);
        if (retirementInfo != null) {
            final String factionId = retirementInfo.getPrevFaction();
            if (HostileActivityEventIntel.get() != null) {
                final String s = factionId;
                switch (s) {
                    case "hegemony": {
                        HostileActivityEventIntel.get().removeActivityCause((Class)HegemonyHostileActivityFactor.class, (Class)HegemonyAICoresActivityCause.class);
                        Global.getSector().getListenerManager().removeListenerOfClass((Class)HegemonyHostileActivityFactor.class);
                        break;
                    }
                    case "tritachyon": {
                        HostileActivityEventIntel.get().removeActivityCause((Class)TriTachyonHostileActivityFactor.class, (Class)TriTachyonStandardActivityCause.class);
                        Global.getSector().getListenerManager().removeListenerOfClass((Class)TriTachyonHostileActivityFactor.class);
                        break;
                    }
                    case "luddic_church": {
                        HostileActivityEventIntel.get().removeActivityCause((Class)LuddicChurchHostileActivityFactor.class, (Class)LuddicChurchStandardActivityCause.class);
                        Global.getSector().getListenerManager().removeListenerOfClass((Class)LuddicChurchHostileActivityFactor.class);
                        if (!Global.getSector().getListenerManager().hasListenerOfClass((Class)LuddicMajorityApplier.class)) {
                            Global.getSector().getListenerManager().addListener((Object)new LuddicMajorityApplier());
                            break;
                        }
                        break;
                    }
                    case "sindrian_diktat": {
                        HostileActivityEventIntel.get().removeActivityCause((Class)SindrianDiktatHostileActivityFactor.class, (Class)SindrianDiktatStandardActivityCause.class);
                        Global.getSector().getListenerManager().removeListenerOfClass((Class)SindrianDiktatHostileActivityFactor.class);
                        DiktatFuelBonusScript.sendGainedMessage();
                        Global.getSector().getPlayerStats().getDynamic().getStat(Stats.getCommodityExportCreditsMultId("fuel")).modifyMult(DiktatFuelBonusScript.MOD_ID, 1.0f + DiktatFuelBonusScript.FUEL_EXPORT_BONUS, "Proven stable source (due to connections in " + Global.getSector().getFaction(retirementInfo.getPrevFaction()).getDisplayName());
                        break;
                    }
                }
            }
        }
    }
    
    public static void unapplyBonusesFromRetirement(final InteractionDialogAPI dialogAPI) {
        final RetirementInfo retirementInfo = (RetirementInfo)Global.getSector().getMemory().get(AoTDRetirementOption.memKey);
        if (retirementInfo != null) {
            final String prevFaction;
            final String factionId = prevFaction = retirementInfo.getPrevFaction();
            switch (prevFaction) {
                case "tritachyon": {
                    if (TriTachyonDeal.get() != null) {
                        TriTachyonDeal.get().endAgreement(TriTachyonDeal.AgreementEndingType.BROKEN, dialogAPI);
                        break;
                    }
                    break;
                }
                case "luddic_church": {
                    LuddicChurchHostileActivityFactor.setDefeatedExpedition(false);
                    Global.getSector().getListenerManager().removeListenerOfClass((Class)LuddicMajorityApplier.class);
                }
                case "sindrian_diktat": {
                    DiktatFuelBonusScript.sendLostMessage();
                    Global.getSector().getPlayerStats().getDynamic().getStat(Stats.getCommodityExportCreditsMultId("fuel")).unmodifyFlat(DiktatFuelBonusScript.MOD_ID);
                    break;
                }
            }
        }
    }
}
